#ifndef XS_TEST_EXPECTATION_H_INCLUDED
#define XS_TEST_EXPECTATION_H_INCLUDED

#include <nlohmann/json.hpp>

#include <string>
#include <unordered_set>


namespace xs { namespace test
{
    class Expectation final
    {
    public:
        Expectation() = delete;
        Expectation(const Expectation&) = delete;
        Expectation(Expectation&&) noexcept = default;
        ~Expectation() noexcept = default;

        Expectation& operator=(const Expectation&) = delete;
        Expectation& operator=(Expectation&&) = delete;

        explicit Expectation(const nlohmann::json& object);
        static bool verify(const nlohmann::json& object) noexcept;

    public:
        std::string name_;
        nlohmann::json request_;
        nlohmann::json response_;
        std::unordered_set<std::string> runs_;
        std::unordered_set<std::string> posts_;
    };
} }

#endif
