#include <chrono>
#include <cstdlib>
#include <iostream>
#include <string>
#include <thread>

#include <boost/filesystem.hpp>

#include "test/Tester.h"
#include "nlohmann/json.hpp"
#include "positivegrid/exchange_server.h"


int main(int argc, char* argv[]) {
    if (argc < 2) {
        std::cerr << "usage: " << argv[0] << " config [delay]" << std::endl;
        return EXIT_SUCCESS;
    }

    const unsigned testDelay = (3 <= argc ? std::stoul(argv[2]) : 0u);

    namespace fs = boost::filesystem;
    const auto configFile = fs::absolute(argv[1]);
    if (!fs::is_regular_file(configFile)) {
        std::cerr << "file \"" << argv[1] << "\" is not exist" << std::endl;
        return EXIT_FAILURE;
    }

    xs::test::Tester tester{configFile};

    std::this_thread::sleep_for(
        std::chrono::seconds(testDelay)
    );

    tester.run();
}
